#pragma once


// STD/STL
#include <chrono>

// Eigen
#include <Eigen/Geometry>

// Simox
#include <VirtualRobot/Robot.h>

// Navigation
#include "Navigation/libraries/core/types.h"
#include <Navigation/libraries/server/execution/ExecutorInterface.h>


namespace armarx::nav::server
{

    class DummyExecutor : virtual public ExecutorInterface
    {

    public:
        struct Params
        {

        };

        DummyExecutor(const VirtualRobot::RobotPtr& robot, const Params& params) : robot(robot)
        {
        }

        ~DummyExecutor() override {}

        void move(const core::Twist& twist) override
        {
            this->twist = twist;
            //const auto now = std::chrono::time_point_cast<std::chrono::microseconds>(std::chrono::steady_clock::now());

            //const float dt = now - lastUpdated;

            //lastUpdated = now;

            const Eigen::Affine3f diff; // = Eigen::Affine3f(Eigen::Translation3f(twist.linear * dt)) * Eigen::Affine3f(Eigen::AngleAxisf(dt, twist.angular)));

            robot->setGlobalPose(robot->getGlobalPose() * diff.matrix());
        }

    private:
        VirtualRobot::RobotPtr robot;

        core::Twist twist;

        std::chrono::microseconds lastUpdated;

    };

}
